// **********************************************************************
//
// Copyright (c) 2003-2017 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.7.0
//
// <auto-generated>
//
// Generated from file `EndpointInfo.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

#ifndef __IceBT_EndpointInfo_h__
#define __IceBT_EndpointInfo_h__

#include <IceUtil/PushDisableWarnings.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/ValueF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/StreamHelpers.h>
#include <Ice/Comparable.h>
#include <IceUtil/ScopedArray.h>
#include <Ice/Optional.h>
#include <Ice/Endpoint.h>
#include <IceUtil/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 307
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

#ifndef ICEBT_API
#   if defined(ICE_STATIC_LIBS)
#       define ICEBT_API /**/
#   elif defined(ICEBT_API_EXPORTS)
#       define ICEBT_API ICE_DECLSPEC_EXPORT
#   else
#       define ICEBT_API ICE_DECLSPEC_IMPORT
#   endif
#endif

#ifdef ICE_CPP11_MAPPING // C++11 mapping

namespace IceBT
{

class EndpointInfo;

}

namespace IceBT
{

class ICE_CLASS(ICEBT_API) EndpointInfo : public ::Ice::EndpointInfo
{
public:

    ICE_MEMBER(ICEBT_API) virtual ~EndpointInfo();

    EndpointInfo() = default;

    EndpointInfo(const EndpointInfo&) = default;
    EndpointInfo(EndpointInfo&&) = default;
    EndpointInfo& operator=(const EndpointInfo&) = default;
    EndpointInfo& operator=(EndpointInfo&&) = default;

    EndpointInfo(const ::std::shared_ptr<::Ice::EndpointInfo>& iceP_underlying, int iceP_timeout, bool iceP_compress, const ::std::string& iceP_addr, const ::std::string& iceP_uuid) :
        ::Ice::EndpointInfo(::std::move(iceP_underlying), iceP_timeout, iceP_compress),
        addr(::std::move(iceP_addr)),
        uuid(::std::move(iceP_uuid))
    {
    }

    ::std::string addr;
    ::std::string uuid;
};

}

namespace Ice
{

}

namespace IceBT
{

using EndpointInfoPtr = ::std::shared_ptr<EndpointInfo>;

}

#else // C++98 mapping

namespace IceBT
{

class EndpointInfo;
ICEBT_API ::Ice::LocalObject* upCast(::IceBT::EndpointInfo*);
typedef ::IceInternal::Handle< ::IceBT::EndpointInfo> EndpointInfoPtr;

}

namespace IceBT
{

class ICEBT_API EndpointInfo : public ::Ice::EndpointInfo
{
public:

    typedef EndpointInfoPtr PointerType;

    virtual ~EndpointInfo();

    EndpointInfo()
    {
    }

    EndpointInfo(const ::Ice::EndpointInfoPtr& iceP_underlying, ::Ice::Int iceP_timeout, bool iceP_compress, const ::std::string& iceP_addr, const ::std::string& iceP_uuid) :
        ::Ice::EndpointInfo(iceP_underlying, iceP_timeout, iceP_compress),
        addr(iceP_addr),
        uuid(iceP_uuid)
    {
    }

    ::std::string addr;
    ::std::string uuid;
};

inline bool operator==(const EndpointInfo& lhs, const EndpointInfo& rhs)
{
    return static_cast<const ::Ice::LocalObject&>(lhs) == static_cast<const ::Ice::LocalObject&>(rhs);
}

inline bool operator<(const EndpointInfo& lhs, const EndpointInfo& rhs)
{
    return static_cast<const ::Ice::LocalObject&>(lhs) < static_cast<const ::Ice::LocalObject&>(rhs);
}

}

namespace Ice
{

}

#endif

#include <IceUtil/PopDisableWarnings.h>
#endif
